open List

class ['a, 'b] assoclist = object(self)
   val mutable list = ([]:('a * 'b) list)

   method add (key:'a) (value:'b) = 
      list <- (key, value)::list
	 
   method get_rem (key:'a) = 
      let res = assoc key list in
	 list <- remove_assoc key list;
	 res

   method rem (key:'a) = 
      list <- remove_assoc key list;
      
	    
   method get (key:'a) =
      assoc key list;

   method empty = 
      length list = 0;
      
   method length = 
      length list;

   method clear = 
      list <- []     
	 
   method list = list

   method set_list l = 
      list <- l

   method first =
      match list with
	  [] -> raise (Failure "Empty list")
	| hd::_ -> hd
end;;
