open String
open Str

let try_find str group =
   try 
      matched_group group str;
   with 
       Not_found -> ""	 
     | Invalid_argument(str) -> "";;

let my_index_from str ch ind =
   try 
      index_from str ind ch;
   with Not_found -> 
      (String.length str) - 1;;

let my_int_of_string str =
   try
      int_of_string str
   with Failure(s) -> -1;;
